Index: modules/BTaggingCMS.cc
===================================================================
--- modules/BTaggingCMS.cc	(revision d38348d6fa05d814372b4af29ec82c9928ff5be9)
+++ modules/BTaggingCMS.cc	(revision d38348d6fa05d814372b4af29ec82c9928ff5be9)
@@ -0,0 +1,421 @@
+/*
+ *  Delphes: a framework for fast simulation of a generic collider experiment
+ *  Copyright (C) 2012-2014  Universite catholique de Louvain (UCL), Belgium
+ *
+ *  This program is free software: you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation, either version 3 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+
+/** \class BTaggingCMS
+ *
+ *  Applies b-tagging efficiency (miss identification rate) formulas
+ *  and sets b-tagging flags
+ *
+ *  \author P. Demin - UCL, Louvain-la-Neuve
+ *
+ */
+
+#include "modules/BTaggingCMS.h"
+
+#include "classes/DelphesClasses.h"
+#include "classes/DelphesFactory.h"
+#include "classes/DelphesFormula.h"
+
+#include "ExRootAnalysis/ExRootResult.h"
+#include "ExRootAnalysis/ExRootFilter.h"
+#include "ExRootAnalysis/ExRootClassifier.h"
+
+#include "TMath.h"
+#include "TString.h"
+#include "TFormula.h"
+#include "TRandom3.h"
+#include "TObjArray.h"
+#include "TDatabasePDG.h"
+#include "TLorentzVector.h"
+
+#include <algorithm>
+#include <stdexcept>
+#include <iostream>
+#include <sstream>
+
+using namespace std;
+
+//------------------------------------------------------------------------------
+
+BTaggingCMS::BTaggingCMS() :
+  fItJetInputArray(0)
+{
+}
+
+//------------------------------------------------------------------------------
+
+BTaggingCMS::~BTaggingCMS()
+{
+}
+
+//------------------------------------------------------------------------------
+
+void BTaggingCMS::Init()
+{
+  map< Int_t, DelphesFormula * >::iterator itEfficiencyMap;
+  ExRootConfParam param;
+  DelphesFormula *formula;
+  Int_t i, size;
+
+  // read efficiency formulas
+  param = GetParam("EfficiencyFormulaLoose");
+  size = param.GetSize();
+
+  fEfficiencyMapLoose.clear();
+  for(i = 0; i < size/2; ++i)
+  {
+    formula = new DelphesFormula;
+    formula->Compile(param[i*2 + 1].GetString());
+    fEfficiencyMapLoose[param[i*2].GetInt()] = formula;
+  }
+
+  // set default efficiency formula
+  itEfficiencyMap = fEfficiencyMapLoose.find(0);
+  if(itEfficiencyMap == fEfficiencyMapLoose.end())
+  {
+    formula = new DelphesFormula;
+    formula->Compile("0.0");
+    fEfficiencyMapLoose[0] = formula;
+  }
+
+  // read efficiency formulas
+  param = GetParam("EfficiencyFormulaMedium");
+  size = param.GetSize();
+
+  fEfficiencyMapMedium.clear();
+  for(i = 0; i < size/2; ++i)
+  {
+    formula = new DelphesFormula;
+    formula->Compile(param[i*2 + 1].GetString());
+    fEfficiencyMapMedium[param[i*2].GetInt()] = formula;
+  }
+
+  // set default efficiency formula
+  itEfficiencyMap = fEfficiencyMapMedium.find(0);
+  if(itEfficiencyMap == fEfficiencyMapMedium.end())
+  {
+    formula = new DelphesFormula;
+    formula->Compile("0.0");
+    fEfficiencyMapMedium[0] = formula;
+  }
+
+  // read efficiency formulas
+  param = GetParam("EfficiencyFormulaTight");
+  size = param.GetSize();
+
+  fEfficiencyMapTight.clear();
+  for(i = 0; i < size/2; ++i)
+  {
+    formula = new DelphesFormula;
+    formula->Compile(param[i*2 + 1].GetString());
+    fEfficiencyMapTight[param[i*2].GetInt()] = formula;
+  }
+
+  // set default efficiency formula
+  itEfficiencyMap = fEfficiencyMapTight.find(0);
+  if(itEfficiencyMap == fEfficiencyMapTight.end())
+  {
+    formula = new DelphesFormula;
+    formula->Compile("0.0");
+    fEfficiencyMapTight[0] = formula;
+  }
+
+  // import input array(s)
+  fJetInputArray = ImportArray(GetString("JetInputArray", "FastJetFinder/jets"));
+  fItJetInputArray = fJetInputArray->MakeIterator();
+}
+
+//------------------------------------------------------------------------------
+
+void BTaggingCMS::Finish()
+{
+  map< Int_t, DelphesFormula * >::iterator itEfficiencyMap;
+  DelphesFormula *formula;
+
+  if(fItJetInputArray) delete fItJetInputArray;
+
+  for(itEfficiencyMap = fEfficiencyMapLoose.begin(); itEfficiencyMap != fEfficiencyMapLoose.end(); ++itEfficiencyMap)
+  {
+    formula = itEfficiencyMap->second;
+    if(formula) delete formula;
+  }
+
+  for(itEfficiencyMap = fEfficiencyMapMedium.begin(); itEfficiencyMap != fEfficiencyMapMedium.end(); ++itEfficiencyMap)
+  {
+    formula = itEfficiencyMap->second;
+    if(formula) delete formula;
+  }
+
+  for(itEfficiencyMap = fEfficiencyMapTight.begin(); itEfficiencyMap != fEfficiencyMapTight.end(); ++itEfficiencyMap)
+  {
+    formula = itEfficiencyMap->second;
+    if(formula) delete formula;
+  }
+}
+
+//------------------------------------------------------------------------------
+
+void BTaggingCMS::Process()
+{
+  Candidate *jet;
+  map< Int_t, DelphesFormula * >::iterator itEfficiencyMap;
+  DelphesFormula *formula;
+  float randomNumber;
+
+  // loop over all input jets
+  fItJetInputArray->Reset();
+
+  while((jet = static_cast<Candidate*>(fItJetInputArray->Next())))
+  {
+    const TLorentzVector &jetMomentum = jet->Momentum;
+
+    randomNumber = gRandom->Uniform();
+
+    // --------------------------
+    // Loose b-tagging
+    // --------------------------
+
+    // find heaviest flavor and b-tag
+    if(fEfficiencyMapLoose.size() != 0)
+    {
+      itEfficiencyMap = fEfficiencyMapLoose.find(jet->FlavorHeaviest);
+      if(itEfficiencyMap == fEfficiencyMapLoose.end())
+      {
+        itEfficiencyMap = fEfficiencyMapLoose.find(0);
+      }
+      formula = itEfficiencyMap->second;
+
+      if(randomNumber <= formula->Eval(jetMomentum.Pt(), jetMomentum.Eta())) jet->BTagHeaviest = 1;
+
+      // find hisghestpt flavor and b-tag
+      itEfficiencyMap = fEfficiencyMapLoose.find(jet->FlavorHighestPt);
+      if(itEfficiencyMap == fEfficiencyMapLoose.end())
+      {
+        itEfficiencyMap = fEfficiencyMapLoose.find(0);
+      }
+      formula = itEfficiencyMap->second;
+
+      if(randomNumber <= formula->Eval(jetMomentum.Pt(), jetMomentum.Eta())) jet->BTagHighestPt = 1;
+
+      // find nearest2 flavor and b-tag
+      itEfficiencyMap = fEfficiencyMapLoose.find(jet->FlavorNearest2);
+      if(itEfficiencyMap == fEfficiencyMapLoose.end())
+      {
+        itEfficiencyMap = fEfficiencyMapLoose.find(0);
+      }
+      formula = itEfficiencyMap->second;
+
+      if(randomNumber <= formula->Eval(jetMomentum.Pt(), jetMomentum.Eta())) jet->BTagNearest2 = 1;
+
+      // find nearest3 flavor and b-tag
+      itEfficiencyMap = fEfficiencyMapLoose.find(jet->FlavorNearest3);
+      if(itEfficiencyMap == fEfficiencyMapLoose.end())
+      {
+        itEfficiencyMap = fEfficiencyMapLoose.find(0);
+      }
+      formula = itEfficiencyMap->second;
+
+      if(randomNumber <= formula->Eval(jetMomentum.Pt(), jetMomentum.Eta())) jet->BTagNearest3 = 1;
+
+      // find nearest3 flavor and b-tag
+      itEfficiencyMap = fEfficiencyMapLoose.find(jet->FlavorAlgo);
+      if(itEfficiencyMap == fEfficiencyMapLoose.end())
+      {
+        itEfficiencyMap = fEfficiencyMapLoose.find(0);
+      }
+      formula = itEfficiencyMap->second;
+
+      if(randomNumber <= formula->Eval(jetMomentum.Pt(), jetMomentum.Eta())) jet->BTagAlgo = 1;
+
+      // find nearest3 flavor and b-tag
+      itEfficiencyMap = fEfficiencyMapLoose.find(jet->FlavorPhysics);
+      if(itEfficiencyMap == fEfficiencyMapLoose.end())
+      {
+        itEfficiencyMap = fEfficiencyMapLoose.find(0);
+      }
+      formula = itEfficiencyMap->second;
+
+      if(randomNumber <= formula->Eval(jetMomentum.Pt(), jetMomentum.Eta())) jet->BTagPhysics = 1;
+
+      // default
+      itEfficiencyMap = fEfficiencyMapLoose.find(jet->FlavorDefault);
+      if(itEfficiencyMap == fEfficiencyMapLoose.end())
+      {
+        itEfficiencyMap = fEfficiencyMapLoose.find(0);
+      }
+      formula = itEfficiencyMap->second;
+
+      if(randomNumber <= formula->Eval(jetMomentum.Pt(), jetMomentum.Eta())) jet->BTagDefault = 1;
+    }
+
+    // --------------------------
+    // Medium b-tagging
+    // --------------------------
+
+    // find heaviest flavor and b-tag
+    if(fEfficiencyMapMedium.size() != 0)
+    {
+      itEfficiencyMap = fEfficiencyMapMedium.find(jet->FlavorHeaviest);
+      if(itEfficiencyMap == fEfficiencyMapMedium.end())
+      {
+        itEfficiencyMap = fEfficiencyMapMedium.find(0);
+      }
+      formula = itEfficiencyMap->second;
+
+      if(randomNumber <= formula->Eval(jetMomentum.Pt(), jetMomentum.Eta())) jet->BTagHeaviest = 2;
+
+      // find hisghestpt flavor and b-tag
+      itEfficiencyMap = fEfficiencyMapMedium.find(jet->FlavorHighestPt);
+      if(itEfficiencyMap == fEfficiencyMapMedium.end())
+      {
+        itEfficiencyMap = fEfficiencyMapMedium.find(0);
+      }
+      formula = itEfficiencyMap->second;
+
+      if(randomNumber <= formula->Eval(jetMomentum.Pt(), jetMomentum.Eta())) jet->BTagHighestPt = 2;
+
+      // find nearest2 flavor and b-tag
+      itEfficiencyMap = fEfficiencyMapMedium.find(jet->FlavorNearest2);
+      if(itEfficiencyMap == fEfficiencyMapMedium.end())
+      {
+        itEfficiencyMap = fEfficiencyMapMedium.find(0);
+      }
+      formula = itEfficiencyMap->second;
+
+      if(randomNumber <= formula->Eval(jetMomentum.Pt(), jetMomentum.Eta())) jet->BTagNearest2 = 2;
+
+      // find nearest3 flavor and b-tag
+      itEfficiencyMap = fEfficiencyMapMedium.find(jet->FlavorNearest3);
+      if(itEfficiencyMap == fEfficiencyMapMedium.end())
+      {
+        itEfficiencyMap = fEfficiencyMapMedium.find(0);
+      }
+      formula = itEfficiencyMap->second;
+
+      if(randomNumber <= formula->Eval(jetMomentum.Pt(), jetMomentum.Eta())) jet->BTagNearest3 = 2;
+
+      // find nearest3 flavor and b-tag
+      itEfficiencyMap = fEfficiencyMapMedium.find(jet->FlavorAlgo);
+      if(itEfficiencyMap == fEfficiencyMapMedium.end())
+      {
+        itEfficiencyMap = fEfficiencyMapMedium.find(0);
+      }
+      formula = itEfficiencyMap->second;
+
+      if(randomNumber <= formula->Eval(jetMomentum.Pt(), jetMomentum.Eta())) jet->BTagAlgo = 2;
+
+      // find nearest3 flavor and b-tag
+      itEfficiencyMap = fEfficiencyMapMedium.find(jet->FlavorPhysics);
+      if(itEfficiencyMap == fEfficiencyMapMedium.end())
+      {
+        itEfficiencyMap = fEfficiencyMapMedium.find(0);
+      }
+      formula = itEfficiencyMap->second;
+
+      if(randomNumber <= formula->Eval(jetMomentum.Pt(), jetMomentum.Eta())) jet->BTagPhysics = 2;
+
+      // default
+      itEfficiencyMap = fEfficiencyMapMedium.find(jet->FlavorDefault);
+      if(itEfficiencyMap == fEfficiencyMapMedium.end())
+      {
+        itEfficiencyMap = fEfficiencyMapMedium.find(0);
+      }
+      formula = itEfficiencyMap->second;
+
+      if(randomNumber <= formula->Eval(jetMomentum.Pt(), jetMomentum.Eta())) jet->BTagDefault = 2;
+    }
+
+    // --------------------------
+    // Tight b-tagging
+    // --------------------------
+
+    // find heaviest flavor and b-tag
+    if(fEfficiencyMapTight.size() != 0)
+    {
+      itEfficiencyMap = fEfficiencyMapTight.find(jet->FlavorHeaviest);
+      if(itEfficiencyMap == fEfficiencyMapTight.end())
+      {
+        itEfficiencyMap = fEfficiencyMapTight.find(0);
+      }
+      formula = itEfficiencyMap->second;
+
+      if(randomNumber <= formula->Eval(jetMomentum.Pt(), jetMomentum.Eta())) jet->BTagHeaviest = 3;
+
+      // find hisghestpt flavor and b-tag
+      itEfficiencyMap = fEfficiencyMapTight.find(jet->FlavorHighestPt);
+      if(itEfficiencyMap == fEfficiencyMapTight.end())
+      {
+        itEfficiencyMap = fEfficiencyMapTight.find(0);
+      }
+      formula = itEfficiencyMap->second;
+
+      if(randomNumber <= formula->Eval(jetMomentum.Pt(), jetMomentum.Eta())) jet->BTagHighestPt = 3;
+
+      // find nearest2 flavor and b-tag
+      itEfficiencyMap = fEfficiencyMapTight.find(jet->FlavorNearest2);
+      if(itEfficiencyMap == fEfficiencyMapTight.end())
+      {
+        itEfficiencyMap = fEfficiencyMapTight.find(0);
+      }
+      formula = itEfficiencyMap->second;
+
+      if(randomNumber <= formula->Eval(jetMomentum.Pt(), jetMomentum.Eta())) jet->BTagNearest2 = 3;
+
+      // find nearest3 flavor and b-tag
+      itEfficiencyMap = fEfficiencyMapTight.find(jet->FlavorNearest3);
+      if(itEfficiencyMap == fEfficiencyMapTight.end())
+      {
+        itEfficiencyMap = fEfficiencyMapTight.find(0);
+      }
+      formula = itEfficiencyMap->second;
+
+      if(randomNumber <= formula->Eval(jetMomentum.Pt(), jetMomentum.Eta())) jet->BTagNearest3 = 3;
+
+      // find nearest3 flavor and b-tag
+      itEfficiencyMap = fEfficiencyMapTight.find(jet->FlavorAlgo);
+      if(itEfficiencyMap == fEfficiencyMapTight.end())
+      {
+        itEfficiencyMap = fEfficiencyMapTight.find(0);
+      }
+      formula = itEfficiencyMap->second;
+
+      if(randomNumber <= formula->Eval(jetMomentum.Pt(), jetMomentum.Eta())) jet->BTagAlgo = 3;
+
+      // find nearest3 flavor and b-tag
+      itEfficiencyMap = fEfficiencyMapTight.find(jet->FlavorPhysics);
+      if(itEfficiencyMap == fEfficiencyMapTight.end())
+      {
+        itEfficiencyMap = fEfficiencyMapTight.find(0);
+      }
+      formula = itEfficiencyMap->second;
+
+      if(randomNumber <= formula->Eval(jetMomentum.Pt(), jetMomentum.Eta())) jet->BTagPhysics = 3;
+
+      // default
+      itEfficiencyMap = fEfficiencyMapTight.find(jet->FlavorDefault);
+      if(itEfficiencyMap == fEfficiencyMapTight.end())
+      {
+        itEfficiencyMap = fEfficiencyMapTight.find(0);
+      }
+      formula = itEfficiencyMap->second;
+
+      if(randomNumber <= formula->Eval(jetMomentum.Pt(), jetMomentum.Eta())) jet->BTagDefault = 3;
+    }
+  }
+}
Index: modules/BTaggingCMS.h
===================================================================
--- modules/BTaggingCMS.h	(revision d38348d6fa05d814372b4af29ec82c9928ff5be9)
+++ modules/BTaggingCMS.h	(revision d38348d6fa05d814372b4af29ec82c9928ff5be9)
@@ -0,0 +1,68 @@
+/*
+ *  Delphes: a framework for fast simulation of a generic collider experiment
+ *  Copyright (C) 2012-2014  Universite catholique de Louvain (UCL), Belgium
+ *
+ *  This program is free software: you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation, either version 3 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#ifndef BTaggingCMS_h
+#define BTaggingCMS_h
+
+/** \class BTaggingCMS
+ *
+ *  Applies b-tagging efficiency (miss identification rate) formulas
+ *  and sets b-tagging flags
+ *
+ *  \author P. Demin - UCL, Louvain-la-Neuve
+ *
+ */
+
+#include "classes/DelphesModule.h"
+#include "classes/DelphesClasses.h"
+
+#include <map>
+
+class TObjArray;
+class DelphesFormula;
+
+class ExRootFilter;
+
+class BTaggingCMS: public DelphesModule
+{
+
+public:
+
+  BTaggingCMS();
+  ~BTaggingCMS();
+
+  void Init();
+  void Process();
+  void Finish();
+
+private:
+
+#if !defined(__CINT__) && !defined(__CLING__)
+  std::map< Int_t, DelphesFormula * > fEfficiencyMapLoose; //!
+  std::map< Int_t, DelphesFormula * > fEfficiencyMapMedium; //!
+  std::map< Int_t, DelphesFormula * > fEfficiencyMapTight; //!
+#endif
+
+  TIterator *fItJetInputArray; //!
+
+  const TObjArray *fJetInputArray; //!
+
+  ClassDef(BTaggingCMS, 1)
+};
+
+#endif
Index: modules/Calorimeter.cc
===================================================================
--- modules/Calorimeter.cc	(revision f53a4d29acc13d296285ecd9b0a986c73a2c0efb)
+++ modules/Calorimeter.cc	(revision d38348d6fa05d814372b4af29ec82c9928ff5be9)
@@ -150,4 +150,12 @@
 */
 
+  // read min E value for timing measurement in ECAL
+  fTimingEMin = GetDouble("TimingEMin",4.);
+  // For timing
+  // So far this flag needs to be false
+  // Curved extrapolation not supported
+  fElectronsFromTrack = false;
+
+  
   // read min E value for towers to be saved
   fECalEnergyMin = GetDouble("ECalEnergyMin", 0.0);
@@ -356,13 +364,4 @@
       fTrackHCalEnergy = 0.0;
 
-      fTowerECalTime = 0.0;
-      fTowerHCalTime = 0.0;
-
-      fTrackECalTime = 0.0;
-      fTrackHCalTime = 0.0;
-
-      fTowerECalTimeWeight = 0.0;
-      fTowerHCalTimeWeight = 0.0;
-
       fTowerTrackHits = 0;
       fTowerPhotonHits = 0;
@@ -380,5 +379,4 @@
       position = track->Position;
 
-
       ecalEnergy = momentum.E() * fTrackECalFractions[number];
       hcalEnergy = momentum.E() * fTrackHCalFractions[number];
@@ -387,9 +385,26 @@
       fTrackHCalEnergy += hcalEnergy;
 
-      fTrackECalTime += TMath::Sqrt(ecalEnergy)*position.T();
-      fTrackHCalTime += TMath::Sqrt(hcalEnergy)*position.T();
-
-      fTrackECalTimeWeight += TMath::Sqrt(ecalEnergy);
-      fTrackHCalTimeWeight += TMath::Sqrt(hcalEnergy);
+      bool dbg_scz = false;
+      if (dbg_scz) {
+	cout << "   Calorimeter input track has x y z t " << track->Position.X() << " " << track->Position.Y() << " " << track->Position.Z() << " " << track->Position.T() 
+	     << endl;
+	Candidate *prt = static_cast<Candidate*>(track->GetCandidates()->Last());
+	const TLorentzVector &ini = prt->Position;
+
+	cout << "                and parent has x y z t " << ini.X() << " " << ini.Y() << " " << ini.Z() << " " << ini.T();
+
+      }
+      
+      if (ecalEnergy > fTimingEMin && fTower) {
+	if (fElectronsFromTrack) {
+	  //	  cout << " SCZ Debug pushing back track hit E=" << ecalEnergy << " T=" << track->Position.T() << " isPU=" << track->IsPU << " isRecoPU=" << track->IsRecoPU 
+	  //	       << " PID=" << track->PID << endl;
+	  fTower->Ecal_E_t.push_back(std::make_pair<float,float>(ecalEnergy,track->Position.T()));
+	} else {
+	  //	  cout << " Skipping track hit E=" << ecalEnergy << " T=" << track->Position.T() << " isPU=" << track->IsPU << " isRecoPU=" << track->IsRecoPU 
+	  //	       << " PID=" << track->PID << endl;
+	}
+      }
+
 
       fTowerTrackArray->Add(track);
@@ -397,5 +412,5 @@
       continue;
     }
-
+  
     // check for photon and electron hits in current tower
     if(flags & 2) ++fTowerPhotonHits;
@@ -412,10 +427,17 @@
     fTowerHCalEnergy += hcalEnergy;
 
-    fTowerECalTime += TMath::Sqrt(ecalEnergy)*position.T();
-    fTowerHCalTime += TMath::Sqrt(hcalEnergy)*position.T();
-
-    fTowerECalTimeWeight += TMath::Sqrt(ecalEnergy);
-    fTowerHCalTimeWeight += TMath::Sqrt(hcalEnergy);
-
+    if (ecalEnergy > fTimingEMin && fTower) {
+      if (abs(particle->PID) != 11 || !fElectronsFromTrack) {
+	//	cout << " SCZ Debug About to push back particle hit E=" << ecalEnergy << " T=" << particle->Position.T() << " isPU=" << particle->IsPU 
+	//   << " PID=" << particle->PID << endl;
+	fTower->Ecal_E_t.push_back(std::make_pair<Float_t,Float_t>(ecalEnergy,particle->Position.T()));
+      } else {
+	
+	// N.B. Only charged particle set to leave ecal energy is the electrons
+	//	cout << " SCZ Debug To avoid double-counting, skipping particle hit E=" << ecalEnergy << " T=" << particle->Position.T() << " isPU=" << particle->IsPU 
+	//	     << " PID=" << particle->PID << endl;
+	
+      }
+    }
 
     fTower->AddCandidate(particle);
@@ -434,6 +456,5 @@
   Double_t ecalEnergy, hcalEnergy;
   Double_t ecalSigma, hcalSigma;
-  Double_t ecalTime, hcalTime, time;
-
+ 
   if(!fTower) return;
 
@@ -444,7 +465,4 @@
   hcalEnergy = LogNormal(fTowerHCalEnergy, hcalSigma);
 
-  ecalTime = (fTowerECalTimeWeight < 1.0E-09 ) ? 0.0 : fTowerECalTime/fTowerECalTimeWeight;
-  hcalTime = (fTowerHCalTimeWeight < 1.0E-09 ) ? 0.0 : fTowerHCalTime/fTowerHCalTimeWeight;
-
   ecalSigma = fECalResolutionFormula->Eval(0.0, fTowerEta, 0.0, ecalEnergy);
   hcalSigma = fHCalResolutionFormula->Eval(0.0, fTowerEta, 0.0, hcalEnergy);
@@ -454,6 +472,5 @@
 
   energy = ecalEnergy + hcalEnergy;
-  time = (TMath::Sqrt(ecalEnergy)*ecalTime + TMath::Sqrt(hcalEnergy)*hcalTime)/(TMath::Sqrt(ecalEnergy) + TMath::Sqrt(hcalEnergy));
-
+    
   if(fSmearTowerCenter)
   {
@@ -469,5 +486,24 @@
   pt = energy / TMath::CosH(eta);
 
-  fTower->Position.SetPtEtaPhiE(1.0, eta, phi, time);
+  // Time calculation for tower
+  fTower->Ntimes = 0;
+  Float_t tow_sumT = 0;
+  Float_t tow_sumW = 0;
+  
+  for (Int_t i = 0 ; i < fTower->Ecal_E_t.size() ; i++) 
+  {
+    Float_t w = TMath::Sqrt(fTower->Ecal_E_t[i].first);
+    tow_sumT += w*fTower->Ecal_E_t[i].second;
+    tow_sumW += w;
+    fTower->Ntimes++;
+  }
+  
+  if (tow_sumW > 0.) {
+    fTower->Position.SetPtEtaPhiE(1.0, eta, phi,tow_sumT/tow_sumW);
+  } else {
+    fTower->Position.SetPtEtaPhiE(1.0,eta,phi,999999.);
+  }
+
+
   fTower->Momentum.SetPtEtaPhiE(pt, eta, phi, energy);
   fTower->Eem = ecalEnergy;
Index: modules/Calorimeter.h
===================================================================
--- modules/Calorimeter.h	(revision f53a4d29acc13d296285ecd9b0a986c73a2c0efb)
+++ modules/Calorimeter.h	(revision d38348d6fa05d814372b4af29ec82c9928ff5be9)
@@ -60,10 +60,7 @@
   Double_t fTrackECalEnergy, fTrackHCalEnergy;
 
-  Double_t fTowerECalTime, fTowerHCalTime;
-  Double_t fTrackECalTime, fTrackHCalTime;
-
-  Double_t fTowerECalTimeWeight, fTowerHCalTimeWeight;
-  Double_t fTrackECalTimeWeight, fTrackHCalTimeWeight;
-
+  Double_t fTimingEMin;
+  Bool_t fElectronsFromTrack; // for timing
+  
   Int_t fTowerTrackHits, fTowerPhotonHits;
 
Index: modules/FastJetFinder.cc
===================================================================
--- modules/FastJetFinder.cc	(revision f53a4d29acc13d296285ecd9b0a986c73a2c0efb)
+++ modules/FastJetFinder.cc	(revision d38348d6fa05d814372b4af29ec82c9928ff5be9)
@@ -66,4 +66,8 @@
 #include "fastjet/contribs/Nsubjettiness/WinnerTakeAllRecombiner.hh"
 
+#include "fastjet/tools/Filter.hh"
+#include "fastjet/tools/Pruner.hh"
+#include "fastjet/contribs/RecursiveTools/SoftDrop.hh"
+
 using namespace std;
 using namespace fastjet;
@@ -121,4 +125,26 @@
   fN = GetInt("N", 2);                  // used only if Njettiness is used as jet clustering algo (case 8)
 
+  //-- Trimming parameters --
+  
+  fComputeTrimming = GetBool("ComputeTrimming", false);
+  fRTrim = GetDouble("RTrim", 0.2);
+  fPtFracTrim = GetDouble("PtFracTrim", 0.05);
+  
+
+  //-- Pruning parameters --
+  
+  fComputePruning = GetBool("ComputePruning", false);
+  fZcutPrun = GetDouble("ZcutPrun", 0.1);
+  fRcutPrun = GetDouble("RcutPrun", 0.5);
+  fRPrun = GetDouble("RPrun", 0.8);
+ 
+  //-- SoftDrop parameters --
+  
+  fComputeSoftDrop     = GetBool("ComputeSoftDrop", false);
+  fBetaSoftDrop        = GetDouble("BetaSoftDrop", 0.0);
+  fSymmetryCutSoftDrop = GetDouble("SymmetryCutSoftDrop", 0.1);
+  fR0SoftDrop= GetDouble("R0SoftDrop=", 0.8);
+  
+
   // ---  Jet Area Parameters ---
   fAreaAlgorithm = GetInt("AreaAlgorithm", 0);
@@ -260,5 +286,5 @@
   PseudoJet jet, area;
   ClusterSequence *sequence;
-  vector< PseudoJet > inputList, outputList;
+  vector< PseudoJet > inputList, outputList, subjets;
   vector< PseudoJet >::iterator itInputList, itOutputList;
   vector< TEstimatorStruct >::iterator itEstimators;
@@ -352,5 +378,85 @@
     candidate->DeltaEta = detaMax;
     candidate->DeltaPhi = dphiMax;
-
+       
+    //------------------------------------
+    // Trimming
+    //------------------------------------
+
+     if(fComputeTrimming)
+    {
+
+      fastjet::Filter    trimmer(fastjet::JetDefinition(fastjet::kt_algorithm,fRTrim),fastjet::SelectorPtFractionMin(fPtFracTrim));
+      fastjet::PseudoJet trimmed_jet = trimmer(*itOutputList);
+      
+      trimmed_jet = join(trimmed_jet.constituents());
+     
+      candidate->TrimmedP4[0].SetPtEtaPhiM(trimmed_jet.pt(), trimmed_jet.eta(), trimmed_jet.phi(), trimmed_jet.m());
+        
+      // four hardest subjets 
+      subjets.clear();
+      subjets = trimmed_jet.pieces();
+      subjets = sorted_by_pt(subjets);
+      
+      candidate->NSubJetsTrimmed = subjets.size();
+
+      for (size_t i = 0; i < subjets.size() and i < 4; i++){
+	if(subjets.at(i).pt() < 0) continue ; 
+ 	candidate->TrimmedP4[i+1].SetPtEtaPhiM(subjets.at(i).pt(), subjets.at(i).eta(), subjets.at(i).phi(), subjets.at(i).m());
+      }
+    }
+    
+    
+    //------------------------------------
+    // Pruning
+    //------------------------------------
+    
+    
+    if(fComputePruning)
+    {
+
+      fastjet::Pruner    pruner(fastjet::JetDefinition(fastjet::cambridge_algorithm,fRPrun),fZcutPrun,fRcutPrun);
+      fastjet::PseudoJet pruned_jet = pruner(*itOutputList);
+
+      candidate->PrunedP4[0].SetPtEtaPhiM(pruned_jet.pt(), pruned_jet.eta(), pruned_jet.phi(), pruned_jet.m());
+         
+      // four hardest subjet 
+      subjets.clear();
+      subjets = pruned_jet.pieces();
+      subjets = sorted_by_pt(subjets);
+      
+      candidate->NSubJetsPruned = subjets.size();
+
+      for (size_t i = 0; i < subjets.size() and i < 4; i++){
+	if(subjets.at(i).pt() < 0) continue ; 
+  	candidate->PrunedP4[i+1].SetPtEtaPhiM(subjets.at(i).pt(), subjets.at(i).eta(), subjets.at(i).phi(), subjets.at(i).m());
+      }
+
+    } 
+     
+    //------------------------------------
+    // SoftDrop
+    //------------------------------------
+   
+    if(fComputeSoftDrop)
+    {
+    
+      contrib::SoftDrop  softDrop(fBetaSoftDrop,fSymmetryCutSoftDrop,fR0SoftDrop);
+      fastjet::PseudoJet softdrop_jet = softDrop(*itOutputList);
+      
+      candidate->SoftDroppedP4[0].SetPtEtaPhiM(softdrop_jet.pt(), softdrop_jet.eta(), softdrop_jet.phi(), softdrop_jet.m());
+        
+      // four hardest subjet 
+      
+      subjets.clear();
+      subjets    = softdrop_jet.pieces();
+      subjets    = sorted_by_pt(subjets);
+      candidate->NSubJetsSoftDropped = softdrop_jet.pieces().size();
+
+      for (size_t i = 0; i < subjets.size()  and i < 4; i++){
+	if(subjets.at(i).pt() < 0) continue ; 
+  	candidate->SoftDroppedP4[i+1].SetPtEtaPhiM(subjets.at(i).pt(), subjets.at(i).eta(), subjets.at(i).phi(), subjets.at(i).m());
+      }
+    }
+  
     // --- compute N-subjettiness with N = 1,2,3,4,5 ----
 
Index: modules/FastJetFinder.h
===================================================================
--- modules/FastJetFinder.h	(revision f53a4d29acc13d296285ecd9b0a986c73a2c0efb)
+++ modules/FastJetFinder.h	(revision d38348d6fa05d814372b4af29ec82c9928ff5be9)
@@ -83,4 +83,24 @@
   Int_t fN ;
 
+  //-- Trimming parameters --
+  
+  Bool_t fComputeTrimming;
+  Double_t fRTrim;
+  Double_t fPtFracTrim;
+  
+  //-- Pruning parameters --
+
+  Bool_t fComputePruning;
+  Double_t fZcutPrun;
+  Double_t fRcutPrun;
+  Double_t fRPrun;
+
+  //-- SoftDrop parameters --
+
+  Bool_t fComputeSoftDrop;
+  Double_t fBetaSoftDrop;
+  Double_t fSymmetryCutSoftDrop;
+  Double_t fR0SoftDrop;
+
   // --- FastJet Area method --------
 
Index: modules/Isolation.cc
===================================================================
--- modules/Isolation.cc	(revision f53a4d29acc13d296285ecd9b0a986c73a2c0efb)
+++ modules/Isolation.cc	(revision d38348d6fa05d814372b4af29ec82c9928ff5be9)
@@ -25,5 +25,5 @@
  *  the transverse momenta fraction within (PTRatioMin, PTRatioMax].
  *
- *  \author P. Demin - UCL, Louvain-la-Neuve
+ *  \author P. Demin, M. Selvaggi, R. Gerosa - UCL, Louvain-la-Neuve
  *
  */
@@ -109,5 +109,8 @@
   fUsePTSum = GetBool("UsePTSum", false);
 
+  fVetoLeptons = GetBool("VetoLeptons", true);  
+  
   fClassifier->fPTMin = GetDouble("PTMin", 0.5);
+
 
   // import input array(s)
@@ -153,5 +156,5 @@
   Candidate *candidate, *isolation, *object;
   TObjArray *isolationArray;
-  Double_t sum, ratio;
+  Double_t sumCharged, sumNeutral, sumAllParticles, sumChargedPU, sumDBeta, ratioDBeta, sumRhoCorr, ratioRhoCorr;
   Int_t counter;
   Double_t eta = 0.0;
@@ -180,7 +183,13 @@
 
     // loop over all input tracks
-    sum = 0.0;
+    
+    sumNeutral = 0.0;
+    sumCharged = 0.0;
+    sumChargedPU = 0.0;
+    sumAllParticles = 0.0;
+   
     counter = 0;
     itIsolationArray.Reset();
+    
     while((isolation = static_cast<Candidate*>(itIsolationArray.Next())))
     {
@@ -188,7 +197,17 @@
 
       if(candidateMomentum.DeltaR(isolationMomentum) <= fDeltaRMax &&
-         candidate->GetUniqueID() != isolation->GetUniqueID())
+         candidate->GetUniqueID() != isolation->GetUniqueID() &&
+	 ( !fVetoLeptons || (TMath::Abs(candidate->PID) != 11 && (TMath::Abs(candidate->PID) != 13)) ) )
       {
-        sum += isolationMomentum.Pt();
+     
+        sumAllParticles += isolationMomentum.Pt();
+        if(isolation->Charge !=0) 
+	{ 
+	  sumCharged += isolationMomentum.Pt();
+          if(isolation->IsRecoPU != 0) sumChargedPU += isolationMomentum.Pt();
+	} 
+  
+        else sumNeutral += isolationMomentum.Pt();
+  
         ++counter;
       }
@@ -209,10 +228,19 @@
     }
 
-    // correct sum for pile-up contamination
-    sum = sum - rho*fDeltaRMax*fDeltaRMax*TMath::Pi();
-
-    ratio = sum/candidateMomentum.Pt();
-    if((fUsePTSum && sum > fPTSumMax) || ratio > fPTRatioMax) continue;
-
+        
+     // correct sum for pile-up contamination
+    sumDBeta = sumCharged + TMath::Max(sumNeutral-0.5*sumChargedPU,0.0);
+    sumRhoCorr = sumCharged + TMath::Max(sumNeutral-TMath::Max(rho,0.0)*fDeltaRMax*fDeltaRMax*TMath::Pi(),0.0);
+    ratioDBeta = sumDBeta/candidateMomentum.Pt();
+    ratioRhoCorr = sumRhoCorr/candidateMomentum.Pt();
+    
+    candidate->IsolationVar = ratioDBeta;
+    candidate->IsolationVarRhoCorr = ratioRhoCorr;
+    candidate->SumPtCharged = sumCharged;
+    candidate->SumPtNeutral = sumNeutral;
+    candidate->SumPtChargedPU = sumChargedPU;
+    candidate->SumPt = sumAllParticles;
+
+    if((fUsePTSum && sumDBeta > fPTSumMax) || ratioDBeta > fPTRatioMax) continue;
     fOutputArray->Add(candidate);
   }
Index: modules/Isolation.h
===================================================================
--- modules/Isolation.h	(revision f53a4d29acc13d296285ecd9b0a986c73a2c0efb)
+++ modules/Isolation.h	(revision d38348d6fa05d814372b4af29ec82c9928ff5be9)
@@ -59,4 +59,6 @@
   Bool_t fUsePTSum;
 
+  Bool_t fVetoLeptons;  
+ 
   IsolationClassifier *fClassifier; //!
 
